﻿/**
 * Pocket Project
 * 
 * @copyright 2007 Power-Station co., Ltd, ALL Rights Reserved,
 */

// ----- GLOBAL.SETTINGS -----
/**
 *  ディレクトリ設定
 */
PE_CSS_DIR     = PE_ROOT_DIR + "css/";
PE_IMAGES_DIR  = PE_ROOT_DIR + "images/";

/**
 *  その他設定
 */
PE_HTML_MODE   = false;

// ----- TOOLBAR.SETTINGS -----
/**
 *  フォントタイプ設定
 */
var PE_FONTS = new Array();
PE_FONTS[0] = new Array("-Font-", "");
PE_FONTS[1] = new Array("ＭＳ 明朝", "ＭＳ 明朝, Courier, serif");
PE_FONTS[2] = new Array("ＭＳ ゴシック", "ＭＳ ゴシック, Helvetica, sans-serif");
PE_FONTS[3] = new Array("Serif", "serif");
PE_FONTS[4] = new Array("Sans Serif", "sans-serif");
PE_FONTS[5] = new Array("Verdana", "Verdana");
PE_FONTS[6] = new Array("Tahoma", "Tahoma");
PE_FONTS[7] = new Array("Arial", "Arial");

/**
 *  フォントサイズ設定
 */
var PE_FONT_SIZES = new Array();
PE_FONT_SIZES[0] = new Array("-Size-", "");
PE_FONT_SIZES[1] = new Array("1", "1");
PE_FONT_SIZES[2] = new Array("2", "2");
PE_FONT_SIZES[3] = new Array("3", "3");
PE_FONT_SIZES[4] = new Array("4", "4");
PE_FONT_SIZES[5] = new Array("5", "5");
PE_FONT_SIZES[6] = new Array("6", "6");
PE_FONT_SIZES[7] = new Array("7", "7");

/**
 *  ツールバーボタン設定
 */
var PE_BUTTON_NAME = new Array();
PE_BUTTON_NAME[0]  = "seperator";
PE_BUTTON_NAME[1]  = "bold";
PE_BUTTON_NAME[2]  = "italic";
PE_BUTTON_NAME[3]  = "underline";
PE_BUTTON_NAME[4]  = "strike";
PE_BUTTON_NAME[5]  = "seperator";
PE_BUTTON_NAME[6]  = "backcolor";
PE_BUTTON_NAME[7]  = "forecolor";
PE_BUTTON_NAME[8]  = "seperator";
PE_BUTTON_NAME[9]  = "link";
PE_BUTTON_NAME[10] = "image";
PE_BUTTON_NAME[11] = "html";

var PE_TOOLBAR_ITEMS = {
    //名前           コマンドID        タイトル属性値    ボタンアイコンパス                       ロールオーバーボタンアイコンパス
    "seperator":     ['',              '',               PE_IMAGES_DIR + 'seperator.gif',         PE_IMAGES_DIR + 'seperator.gif'],
    "bold":          ['Bold',          '太字',           PE_IMAGES_DIR + 'bold_off.gif',          PE_IMAGES_DIR + 'bold_on.gif'],
    "italic":        ['Italic',        '斜体'  ,         PE_IMAGES_DIR + 'italic_off.gif',        PE_IMAGES_DIR + 'italic_on.gif'],
    "underline":     ['Underline',     '下線',           PE_IMAGES_DIR + 'underline_off.gif',     PE_IMAGES_DIR + 'underline_on.gif'],
    "strike":        ['Strikethrough', '取消し線',       PE_IMAGES_DIR + 'strike_off.gif',        PE_IMAGES_DIR + 'strike_on.gif'],
    "seperator":     ['',              '',               PE_IMAGES_DIR + 'seperator.gif',         PE_IMAGES_DIR + 'seperator.gif'],
    "backcolor":     ['BackColor',     '背景色',         PE_IMAGES_DIR + 'backcolor_off.gif',     PE_IMAGES_DIR + 'backcolor_on.gif'],
    "forecolor":     ['ForeColor',     '文字色',         PE_IMAGES_DIR + 'forecolor_off.gif',     PE_IMAGES_DIR + 'forecolor_on.gif'],
    "seperator":     ['',              '',               PE_IMAGES_DIR + 'seperator.gif',         PE_IMAGES_DIR + 'seperator.gif'],
    "link":          ['CreateLink',    'リンク挿入',     PE_IMAGES_DIR + 'link_off.gif',          PE_IMAGES_DIR + 'link_on.gif'],
    "image":         ['InsertImage',   'イメージ挿入',   PE_IMAGES_DIR + 'image_off.gif',         PE_IMAGES_DIR + 'image_on.gif'],
    "html":          ['viewHTML',      'HTML表示',       PE_IMAGES_DIR + 'html_off.gif',          PE_IMAGES_DIR + 'html_on.gif']
};

// ----- FUNCTION -----
/**
 *  エディタを表示する
 *
 *  @param  string  $objTextareaId   テキストエリアのID文字列
 *  @param  int     $intWidth        エディタの幅
 *  @param  int     $intHeight       エディタの高さ
 *  @return 
 */
function pe_drawingPocketEditor(objTextareaId, intWidth, intHeight)
{
    // CSSの読込み
    document.write('<link rel="stylesheet" type="text/css" href="' + PE_CSS_DIR + 'default.css">\n');

    // 注意書きの出力
    var caution = "<pre class='pe-toolbar-caution'><div class='fd_caution fs_s'>※改行(&lt;BR&gt;)はShiftキーを押しながらEnterキーを押してください</div></pre>";
    document.getElementById(objTextareaId).insertAdjacentHTML("BEFOREBEGIN", caution);

    //高さ・幅の設定
    PE_EDITOR_WIDTH  = intWidth;
    PE_EDITOR_HEIGHT = intHeight;

    // テキストエリアの非表示設定
    document.getElementById(objTextareaId).style.display = "none";

    //ツールバースタイルの設定
    if (navigator.appName == "Microsoft Internet Explorer")
    {
        var tb_style_valign = "middle";
    } else {
        var tb_style_valign = "bottom";
    }

    //ツールバー文字列の生成
    var toolbar = '';
    toolbar += '<table class="pe-toolbar-edit-area" cellpadding="0" cellspacing="0" border="0" style="width:' + (parseFloat(PE_EDITOR_WIDTH) + 4) + 'px;">';
    toolbar += '<tr><td style="width: 3px;"></td>';

    // ドロップダウンリスト文字列の生成
    toolbar += '<td style="width: 95px;">' + pe_createDropDown(objTextareaId, "FontSelect", PE_FONTS) + '</td>';
    toolbar += '<td style="width: 40px;">' + pe_createDropDown(objTextareaId, "FontSizes", PE_FONT_SIZES) + '</td>';

    // ボタン文字列の生成
    for (var i = 0; i <= PE_BUTTON_NAME.length;)
    {
        if (PE_BUTTON_NAME[i])
        {
            var objBtn       = PE_TOOLBAR_ITEMS[PE_BUTTON_NAME[i]];
            var objBtnID     = objBtn[0];
            var objBtnTitle  = objBtn[1];
            var objBtnImage  = objBtn[2];
            var objBtnImageR = objBtn[3];
            // セパレータかチェック
            if (PE_BUTTON_NAME[i] == "seperator")
            {
                toolbar += '<td style="padding:0px; width:10px; vertical-align:' + tb_style_valign + ';" align="center"><img src="' + objBtnImage + '" border=0 unselectable="on" width="2" height="20" hspace="2" unselectable="on"></td>';
            }
            else if (PE_BUTTON_NAME[i] == "html")
            {
                toolbar += '<td style="padding:0px; width:20px; vertical-align:' + tb_style_valign + ';">';
                toolbar += '<span id="HTMLMode' + objTextareaId + '"><img src="' + objBtnImage + '" border=0 unselectable="on" title="' + objBtnTitle + '" id="' + objBtnID + '" class="pe-toolbar-button" onClick="pe_formatContents(this.id,\'' + objTextareaId + '\');" onmouseover="if(className==\'pe-toolbar-button\'){className=\'pe-toolbar-button-over\'}; this.src=\'' + objBtnImageR + '\';" onmouseout="if(className==\'pe-toolbar-button-over\'){className=\'pe-toolbar-button\'}; this.src=\'' + objBtnImage + '\';" unselectable="on"></span>';
                toolbar += '<span id="TEXTMode' + objTextareaId + '"><img src="' + PE_IMAGES_DIR + 'text_off.gif" border=0 unselectable="on" title="テキスト表示" id="viewTEXT" class="pe-toolbar-button" onClick="pe_formatContents(this.id,\'' + objTextareaId + '\');" onmouseover="if(className==\'pe-toolbar-button\'){className=\'pe-toolbar-button-over\'}; this.src=\'' + PE_IMAGES_DIR + 'text_on.gif\';" onmouseout="if(className==\'pe-toolbar-button-over\'){className=\'pe-toolbar-button\'}; this.src=\'' + PE_IMAGES_DIR + 'text_off.gif\';" unselectable="on"></span>';
                toolbar += '</td>';
            }
            else {
                toolbar += '<td style="padding:0px; width:20px; vertical-align:' + tb_style_valign + ';"><img src="' + objBtnImage + '" border=0 unselectable="on" title="' + objBtnTitle + '" id="' + objBtnID + '" class="pe-toolbar-button" onClick="pe_formatContents(this.id,\'' + objTextareaId + '\');" onmouseover="if(className==\'pe-toolbar-button\'){className=\'pe-toolbar-button-over\'}; this.src=\'' + objBtnImageR + '\';" onmouseout="if(className==\'pe-toolbar-button-over\'){className=\'pe-toolbar-button\'}; this.src=\'' + objBtnImage + '\';" unselectable="on">';
                // 背景色かチェック
                if (PE_BUTTON_NAME[i] == "backcolor")
                {
                    toolbar += '<div id="pe_backcolorPalette" style="z-index:1; display:none;">';
                    toolbar += '<div style="position:relative;"></div>';
                    toolbar += '<div style="position:absolute; width:117px; height:49px; background-color:#999999;">';
                    toolbar += '<table border=1 style="cursor: pointer;">';
                    toolbar += '<tr>';
                    toolbar += '<td id="pe_backcolorViewer" style="height:20px; background-color:#000000;" colspan="9"></td>';
                    toolbar += '</tr>';
                    toolbar += '<tr>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#000000;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#000000\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#000000\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#007700;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#007700\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#007700\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#00FF00;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#00FF00\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#00FF00\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#770000;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#770000\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#770000\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#777700;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#777700\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#777700\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#77FF00;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#77FF00\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#77FF00\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#FF0000;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#FF0000\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#FF0000\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#FF7700;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#FF7700\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#FF7700\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#FFFF00;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#FFFF00\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#FFFF00\')"></td>';
                    toolbar += '</tr>';
                    toolbar += '<tr>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#000077;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#000077\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#000077\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#007777;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#007777\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#007777\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#00FF77;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#00FF77\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#00FF77\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#770077;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#770077\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#770077\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#777777;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#777777\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#777777\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#77FF77;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#77FF77\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#77FF77\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#FF0077;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#FF0077\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#FF0077\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#FF7777;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#FF7777\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#FF7777\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#FFFF77;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#FFFF77\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#FFFF77\')"></td>';
                    toolbar += '</tr>';
                    toolbar += '<tr>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#0000FF;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#0000FF\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#0000FF\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#0077FF;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#0077FF\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#0077FF\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#00FFFF;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#00FFFF\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#00FFFF\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#7700FF;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#7700FF\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#7700FF\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#7777FF;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#7777FF\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#7777FF\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#77FFFF;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#77FFFF\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#77FFFF\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#FF00FF;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#FF00FF\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#FF00FF\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#FF77FF;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#FF77FF\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#FF77FF\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#FFFFFF;" onMouseOver="pe_viewColor(\'pe_backcolorViewer\',\'#FFFFFF\')" onMouseDown="pe_setBackColor(\'' + objTextareaId + '\', \'#FFFFFF\')"></td>';
                    toolbar += '</tr>';
                    toolbar += '</table>';
                    toolbar += '</div>';
                    toolbar += '</div>';
                }
                // 文字色かチェック
                else if (PE_BUTTON_NAME[i] == "forecolor")
                {
                    toolbar += '<div id="pe_forecolorPalette" style="z-index:1; display:none;">';
                    toolbar += '<div style="position:relative;"></div>';
                    toolbar += '<div style="position:absolute; width:117px; height:49px; background-color:#999999;">';
                    toolbar += '<table border=1 style="cursor: pointer;">';
                    toolbar += '<tr>';
                    toolbar += '<td id="pe_forecolorViewer" style="height:20px; background-color:#000000;" colspan="9"></td>';
                    toolbar += '</tr>';
                    toolbar += '<tr>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#000000;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#000000\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#000000\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#007700;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#007700\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#007700\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#00FF00;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#00FF00\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#00FF00\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#770000;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#770000\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#770000\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#777700;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#777700\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#777700\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#77FF00;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#77FF00\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#77FF00\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#FF0000;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#FF0000\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#FF0000\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#FF7700;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#FF7700\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#FF7700\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#FFFF00;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#FFFF00\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#FFFF00\')"></td>';
                    toolbar += '</tr>';
                    toolbar += '<tr>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#000077;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#000077\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#000077\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#007777;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#007777\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#007777\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#00FF77;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#00FF77\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#00FF77\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#770077;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#770077\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#770077\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#777777;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#777777\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#777777\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#77FF77;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#77FF77\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#77FF77\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#FF0077;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#FF0077\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#FF0077\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#FF7777;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#FF7777\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#FF7777\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#FFFF77;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#FFFF77\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#FFFF77\')"></td>';
                    toolbar += '</tr>';
                    toolbar += '<tr>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#0000FF;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#0000FF\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#0000FF\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#0077FF;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#0077FF\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#0077FF\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#00FFFF;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#00FFFF\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#00FFFF\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#7700FF;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#7700FF\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#7700FF\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#7777FF;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#7777FF\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#7777FF\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#77FFFF;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#77FFFF\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#77FFFF\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#FF00FF;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#FF00FF\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#FF00FF\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#FF77FF;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#FF77FF\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#FF77FF\')"></td>';
                    toolbar += '<td style="width:10px; height:10px; background-color:#FFFFFF;" onMouseOver="pe_viewColor(\'pe_forecolorViewer\',\'#FFFFFF\')" onMouseDown="pe_setForeColor(\'' + objTextareaId + '\', \'#FFFFFF\')"></td>';
                    toolbar += '</tr>';
                    toolbar += '</table>';
                    toolbar += '</div>';
                    toolbar += '</div>';
                }

                toolbar += '</td>';
            }
        }
        i++;
    }

    toolbar += "<td>&nbsp;</td></tr></table>";

    // エディタ表示IFRAME設定
    var iframe = '<table class="pe-toolbar-edit-area" cellpadding="0" cellspacing="0"><tr><td>'
               + '<iframe frameborder="0" id="iframePE' + objTextareaId + '"></iframe>'
               + '</td></tr></table>';

    // テキストエリア後にツールバーとIFRAMEを挿入
    document.getElementById(objTextareaId).insertAdjacentHTML("AFTEREND", toolbar + iframe);

    // テキスト表示ボタンを非表示
    document.getElementById("TEXTMode" + objTextareaId).style.display = 'none';

    // IFRAMEに高さ・幅を設定
    document.getElementById("iframePE" + objTextareaId).style.height = PE_EDITOR_HEIGHT + "px";
    document.getElementById("iframePE" + objTextareaId).style.width  = PE_EDITOR_WIDTH  + "px";

    // テキストエリアの内容を取得
    var content = document.getElementById(objTextareaId).value;

    // IFRAMEのwindow,documentオブジェクトを取得する
    var doc = document.getElementById("iframePE" + objTextareaId).contentWindow.document;
    doc.open();
    doc.write(content);
    doc.close();

    // IFRAMEのHEAD内にスタイルシートのリンクエレメントを追加
    var cssElement  = doc.createElement("LINK");
    cssElement.rel  = "stylesheet";
    cssElement.type = "text/css";
    cssElement.href = PE_CSS_DIR + "styles.css";
    doc.getElementsByTagName("HEAD")[0].appendChild(cssElement);

    // IFRAMEを編集可能にする
    doc.body.contentEditable = true;
    doc.designMode = "on";

    // SUBMIT時、エディターの内容で既存TEXTAREAを更新
    if (navigator.appName == "Microsoft Internet Explorer")
    {
        for (var idx=0; idx < document.forms.length; idx++)
        {
            document.forms[idx].attachEvent("onsubmit", function() { pe_submit(objTextareaId); });
        }
    }
    else {
        for (var idx=0; idx < document.forms.length; idx++)
        {
            document.forms[idx].addEventListener("submit", function OnSumbmit() { pe_submit(objTextareaId); }, true);
        }
    }
}

/**
 *  ドロップダウンリストを作成する
 *
 *  @param  string  $objTextareaId  テキストエリアのID文字列
 *  @param  string  $objID          ドロップダウンリストID文字列
 *  @param  array   $arrItems       リストアイテム配列
 *  @param  string  $label          ラベル
 *  @return string  $arrDropDown    HTML文字列
 */
function pe_createDropDown(objTextareaId, objID, arrItems)
{
    arrItems.sort();
    var arrDropDown = "";
    arrDropDown += '<select id="' + objID + '" name="' + objID + '" onchange="pe_formatContents(\'' + objID + '\',\'' + objTextareaId + '\',this.form.' + objID + '.value);">';
    for (var i = 0; i < arrItems.length;)
    {
        if (arrItems[i]) arrDropDown += '<option value="' + arrItems[i][1] + '">' + arrItems[i][0] + '&nbsp;</option>';
        i++;
    }
    arrDropDown += "</select>";
    return arrDropDown;
}

/**
 *  コンテンツ内容を整形する
 *
 *  @param  string  $objID          コントロールID
 *  @param  string  $objTextareaId  テキストエリアのID文字列
 *  @param  array   $value          選択値
 *  @return 
 */
function pe_formatContents(objID, objTextareaId, value)
{
    // ツールバーボタンクリック時、IFRAMEにフォーカスを移動
    document.getElementById("iframePE" + objTextareaId).contentWindow.focus();

    // 編集モードをチェック
    if (PE_HTML_MODE && objID != "viewTEXT") return;

    // ボタン種別の判定
    if (objID == "FontSizes" && value != "")
    {
        // フォントサイズ変更
        document.getElementById("iframePE" + objTextareaId).contentWindow.document.execCommand("FontSize", false, value);
    }
    else if (objID == "FontSelect" && value != "")
    {
        // フォントタイプ変更
        document.getElementById("iframePE" + objTextareaId).contentWindow.document.execCommand("FontName", false, value);
    }
    else if (objID == "BackColor")
    {
        // 背景色
        if (document.getElementById("pe_backcolorPalette").style.display == "none")
        {
            document.getElementById("pe_backcolorPalette").style.display = ""
            document.getElementById("pe_forecolorPalette").style.display = "none"
        }
        else {
            document.getElementById("pe_backcolorPalette").style.display = "none"
        }
    }
    else if (objID == "ForeColor")
    {
        // 文字色
        if (document.getElementById("pe_forecolorPalette").style.display == "none")
        {
            document.getElementById("pe_forecolorPalette").style.display = ""
            document.getElementById("pe_backcolorPalette").style.display = "none"
        }
        else {
            document.getElementById("pe_forecolorPalette").style.display = "none"
        }
    }
    else if (objID == "CreateLink")
    {
        // リンクの挿入
        window.open(PE_LINK_DIALOG_URL + '&iframe=' + objTextareaId,'dialog','location=0,status=0,scrollbars=0,resizable=0,width=' + PE_LINK_DIALOG_W + ',height=' + PE_LINK_DIALOG_H);
    }
    else if (objID == "InsertImage")
    {
        // イメージの挿入
        window.open(PE_IMG_DIALOG_URL + '&iframe=' + objTextareaId,'dialog','location=0,status=0,scrollbars=0,resizable=0,width=' + PE_IMG_DIALOG_W + ',height=' + PE_IMG_DIALOG_H);
    }
    else if (objID == "viewHTML")
    {
        // HTMLの編集
        pe_viewHTML(objTextareaId);
    }
    else if (objID == "viewTEXT")
    {
        // テキストの表示
        pe_viewTEXT(objTextareaId);
    }
    else {
        // その他（Bold、Italicなど）
        document.getElementById("iframePE" + objTextareaId).contentWindow.document.execCommand(objID, false, null);
    }
}

/**
 *  エディターの内容をテキストエリアに設定
 *
 *  @param  string  $objTextareaId  テキストエリアのID文字列
 *  @return 
 */
function pe_submit(objTextareaId)
{
    document.getElementById(objTextareaId).value = document.getElementById("iframePE" + objTextareaId).contentWindow.document.body.innerHTML;
}

/**
 *  Netscape 6/Mozillaでも動作する様に、
 *  insertAdjacentHTML(),insertAdjacentText(),insertAdjacentElement()をエミュレートする
 *
 *  @param  string  $where        挿入位置
 *  @param  string  $parsedNode   挿入オブジェクトHTML文字列
 *  @return 
 */
if (typeof HTMLElement != "undefined" && !HTMLElement.prototype.insertAdjacentElement)
{
    HTMLElement.prototype.insertAdjacentElement =
        function(where, parsedNode)
        {
            switch (where)
            {
            // 開始タグの前（タグ外）
            case "BEFOREBEGIN":
                this.parentNode.insertBefore(parsedNode,this);
                break;
            // 開始タグの後（タグ内）
            case "AFTERBEGIN":
                this.insertBefore(parsedNode,this.firstChild);
                break;
            // 終了タグの前（タグ内）
            case "BEFOREEND":
                this.appendChild(parsedNode);
                break;
            // 終了タグの後（タグ外）
            case "AFTEREND":
                if (this.nextSibling)
                this.parentNode.insertBefore(parsedNode,this.nextSibling);
                else this.parentNode.appendChild(parsedNode);
                break;
        }
    }

    HTMLElement.prototype.insertAdjacentHTML =
        function(where, htmlStr)
        {
            var r = this.ownerDocument.createRange();
            r.setStartBefore(this);
            var parsedHTML = r.createContextualFragment(htmlStr);
            this.insertAdjacentElement(where,parsedHTML);
        }

    HTMLElement.prototype.insertAdjacentText =
        function(where, txtStr)
        {
            var parsedText = document.createTextNode(txtStr);
            this.insertAdjacentElement(where,parsedText);
        }
}

/**
 *  現在のページにHTMLを挿入する
 *
 *  @param  string  $html           HTML文字列
 *  @param  string  $objTextareaId  テキストエリアのID文字列
 *  @return 
 */
function pe_insertHTML(html, objTextareaId)
{
    // ブラウザ判断
    if (navigator.appName == "Microsoft Internet Explorer")
    {
        document.getElementById("iframePE" + objTextareaId).contentWindow.document.selection.createRange().pasteHTML(html);
    }
    else {
        // DIVエレメントオブジェクトを作成
        var div = document.getElementById("iframePE" + objTextareaId).contentWindow.document.createElement("div");
        // IMAGEのHTML文字列を設定
        div.innerHTML = html;
        // 作成したHTML文字列を出力
        var node = pe_insertNode(div, objTextareaId);
    }
}

/**
 *  現在のページにHTMLを挿入する（mozilla用）
 *
 *  @param  string  $objNode        エレメントオブジェクト
 *  @param  string  $objTextareaId  テキストエリアのID文字列
 *  @return 
 */
function pe_insertNode(objNode, objTextareaId)
{

    // 現在の選択範囲を取得
    var selPos = document.getElementById("iframePE" + objTextareaId).contentWindow.getSelection();

    // 選択範囲の最初の位置を取得
    var range = selPos.getRangeAt(0);

    // 選択状態を全て破棄
    selPos.removeAllRanges();

    // 選択されたノードと文字の全てを削除
    range.deleteContents();

    // 選択開始位置を取得
    var container = range.startContainer;

    // 選択範囲の対象位置の先頭ノード内での開始文字位置を取得
    var pos = range.startOffset;

    // 新しい選択位置オブジェクトを作成
    range=document.createRange();

    // 挿入するノートがTEXT_NODEかを判断
    if (container.nodeType==3 && objNode.nodeType==3)
    {
        // IMAGEを挿入
        container.insertData(pos, objNode.nodeValue);
        // カーソルの設定
        range.setEnd(container, pos + objNode.length);
        range.setStart(container, pos + objNode.length);
    }
    else {
        var afterNode;
        if (container.nodeType==3)
        {
            // 仮想的なノードを作成
            var textNode = container;
            container = textNode.parentNode;
            var text = textNode.nodeValue;

            // 選択開始位置前文字列の取得
            var textBefore = text.substr(0,pos);
            // 選択開始位置後文字列の取得
            var textAfter = text.substr(pos);

            var beforeNode = document.createTextNode(textBefore);
            afterNode = document.createTextNode(textAfter);

            // IMAGEを挿入
            container.insertBefore(afterNode, textNode);
            container.insertBefore(objNode, afterNode);
            container.insertBefore(beforeNode, objNode);

            // 子ノードを削除
            container.removeChild(textNode);
        }
        else {
            // 上記以外のノードの場合
            afterNode = container.childNodes[pos];
            container.insertBefore(objNode, afterNode);
        }

        // カーソルの設定
        range.setEnd(afterNode, 0);
        range.setStart(afterNode, 0);
    }

    selPos.addRange(range);
}

/**
 *  指定カラーのプレビュー表示を行う
 *
 *  @param  string  $objPaletteId   パレットエリアのID文字列
 *  @param  string  $color          16進カラー
 */
function pe_viewColor(objPaletteId, color)
{
    document.getElementById(objPaletteId).style.backgroundColor = color;
}

/**
 *  背景色を指定カラーに設定する
 *
 *  @param  string  $objTextareaId  テキストエリアのID文字列
 *  @param  string  $color          16進カラー
 */
function pe_setBackColor(objTextareaId, color)
{
    var command;

    // ブラウザ判断
    if (navigator.appName == "Microsoft Internet Explorer")
    {
        command = "BackColor";
    }
    else {
        command = "hilitecolor";
    }
    document.getElementById("iframePE" + objTextareaId).contentWindow.document.execCommand(command, false, color);
    document.getElementById("pe_backcolorPalette").style.display = "none";
}

/**
 *  フォント色を指定カラーに設定する
 *
 *  @param  string  $objTextareaId  テキストエリアのID文字列
 *  @param  string  $color          16進カラー
 */
function pe_setForeColor(objTextareaId, color)
{
    document.getElementById("iframePE" + objTextareaId).contentWindow.document.execCommand("ForeColor", false, color);
    document.getElementById("pe_forecolorPalette").style.display = "none";
}

/**
 *  HTMLソースを表示する
 *
 *  @param  string  $objTextareaId  テキストエリアのID文字列
 */
function pe_viewHTML(objTextareaId)
{
    var doc = document.getElementById("iframePE" + objTextareaId).contentWindow.document;

    // ブラウザ判断
    if (navigator.appName == "Microsoft Internet Explorer")
    {
        // HTML文字列を取得・設定
        doc.body.innerText = doc.body.innerHTML;
    }
    else {
        // HTML文字列を取得・設定
        var text = document.createTextNode(doc.body.innerHTML);
        doc.body.innerHTML = "";
        doc.body.appendChild(text);
    }

    // ボタンの表示を変更
    document.getElementById("HTMLMode" + objTextareaId).style.display = "none"; 
    document.getElementById("TEXTMode" + objTextareaId).style.display = "";

    PE_HTML_MODE = true;
};

/**
 *  テキストを表示する
 *
 *  @param  string  $objTextareaId  テキストエリアのID文字列
 */
function pe_viewTEXT(objTextareaId)
{ 
    var doc = document.getElementById("iframePE" + objTextareaId).contentWindow.document;

    // ブラウザ判断
    if (navigator.appName == "Microsoft Internet Explorer")
    {
        // テキスト文字列を取得・設定
        doc.body.innerHTML = doc.body.innerText;
    }
    else {
        // テキスト文字列を取得・設定
        var text = doc.body.ownerDocument.createRange();
        text.selectNodeContents(doc.body);
        doc.body.innerHTML = text.toString();
    }

    // ボタンの表示を変更
    document.getElementById("TEXTMode" + objTextareaId).style.display = "none"; 
    document.getElementById("HTMLMode" + objTextareaId).style.display = "";

    PE_HTML_MODE = false;
};
