<?php
/**
 * Pocket Project
 * 
 * @copyright 2006 Power-Station co., Ltd, ALL Rights Reserved,
 */

/**
 *  PING送信URL登録用のActionクラス
 *
 *  @author     Koji Hasegawa
 *  @access     public
 *  @package    PocketBlog.pc.do
 */
class configPingInsertAction extends Pocket_Blog_Action
{
    /**
     *  アクション実行
     *
     *  @access public
     *  @param  object  $controller         コントローラ
     *  @param  object  $request            リクエスト情報
     *  @return string  success,error
     */
    function execute(&$controller, &$request)
    {
        // リクエスト情報の取得
        $url  = $request['url'];
        $mode = $request['mode'];
        
        // PING送信URLの登録
        db_insert_ping($url, $mode);

        // メッセージの作成
        $params = array('msg' => 'PING送信URLを登録しました。');

        // リダイレクト
        pocket_redirect('configPing.view', $params);
    }

    /**
     *  リクエスト検証
     *
     *  @access public
     *  @param  object  $validator          バリデータ
     *  @param  object  $request            リクエスト情報
     */
    function validate(&$validator, &$request)
    {
        // リクエスト情報の取得
        $url  = $request['url'];
        $mode = $request['mode'];

        // エラー表示用のAction名称の設定
        $this->viewAction = 'configPing';

        // 検証
        $validator->validate('url' , 'URL'       , $url , 'url'   , true);
        $validator->validate('mode', '送信モード', $mode, 'number');
    }

    /**
     *  認証アクションフラグ
     *
     *  @access public
     *  @return boolean true,false
     */
    function isSecure()
    {
        return true;
    }
}

?>
