<?php
/**
 * Pocket Project
 * 
 * @copyright 2006 Power-Station co., Ltd, ALL Rights Reserved,
 */

/**
 *  RSS1.0表示用のActionクラス
 *
 *  @author     Shogo Minami
 *  @access     public
 *  @package    PocketBlog.pc.view
 */
class rss10Action extends Pocket_Blog_Action
{
    /**
     *  アクション実行
     *
     *  @access public
     *  @param  object  $controller         コントローラ
     *  @param  object  $request            リクエスト情報
     *  @return string  success,error
     */
    function execute(&$controller, &$request)
    {
        // リクエスト情報の取得
        $comment   = $request['comment'];
        $trackback = $request['trackback'];

        /**
         *  メイン情報の取得、設定
         */
         if (isset($comment))
         {
            // 最新のコメント情報（RSS用）の取得、設定
            $this->assign('rss_list', db_get_post_comments4latest_comment_rss(NEWS_SIZE));
         }
         elseif (isset($trackback))
         {
            // 最新のトラックバック情報（RSS用）の取得、設定
            $this->assign('rss_list', db_get_trackbacks4latest_trackback_rss(NEWS_SIZE));
         }
         else {
            // 最新の記事一覧情報（RSS用）の取得、設定
            $this->assign('rss_list', db_get_posts4latest_post_rss(NEWS_SIZE));
         }

        // HTTPヘッダの設定
        $controller->setContentType("Content-type: text/xml;charset=" . $this->smarty->output_charset);

        /**
         *  基本情報の設定
         */
        // RSSのURLの設定
        $this->assign('rss_url', pocket_getSiteUrl() . '?m=pc&a=rss10');

        return POCKET_ACTION_SUCCESS;
    }
}

?>
